require 'spec_helper_acceptance'

describe 'cfssl' do
  context 'with defaults' do
    pp = %(
      include cfssl
    )

    it 'applies without error' do
      apply_manifest(pp, catch_failures: true)
    end
    it 'applies idempotently' do
      apply_manifest(pp, catch_changes: true)
    end

    describe port(8080) do
      it { is_expected.to be_listening.on('127.0.0.1').with('tcp') }
    end

    describe command('curl -s -d "{}" -H "Content-Type: application/json" -X POST 127.0.0.1:8080/api/v1/cfssl/info') do
      its(:stdout) { is_expected.to match %r{BEGIN CERTIFICATE} }
    end
    describe command('openssl crl -in /var/cfssl/crl.pem -text -noout') do
      # rubocop:disable RSpec/RepeatedDescription
      its(:stdout) { is_expected.to match %r{Certificate Revocation List } }
      its(:stdout) { is_expected.to match %r{Issuer: C = FR, L = MONTPELLIER, O = EXEMPLE ORG, OU = IT Dept, CN = EXEMPLE ROOT CA GEN1} }
      its(:stdout) { is_expected.to match %r{No Revoked Certificates} }
    end
  end
end
